Skip to content
Start here

Get multiple key-value pairs

kv.namespaces.bulk_get(strnamespace_id, NamespaceBulkGetParams**kwargs) -> NamespaceBulkGetResponse
POST/accounts/{account_id}/storage/kv/namespaces/{namespace_id}/bulk/get

Retrieves the text-based values of up to 100 keys from the specified Workers KV namespace. The result maps each requested key to its value. Set type to json to parse JSON values instead of returning strings, and set withMetadata to true to include metadata with each value. Binary values are not supported by this operation.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Workers KV Storage WriteWorkers KV Storage Read
ParametersExpand Collapse
account_id: str

ID of the Cloudflare account that owns the Workers KV namespaces.

maxLength32
namespace_id: str

ID of the Workers KV namespace.

maxLength32
keys: Sequence[str]

Array of keys to retrieve (maximum of 100).

type: Optional[Literal["text", "json"]]

Return values as strings with text, or parse stored JSON values with json.

One of the following:
"text"
"json"
with_metadata: Optional[bool]

Whether to include metadata in the response.

ReturnsExpand Collapse
Optional[NamespaceBulkGetResponse]
One of the following:
class WorkersKVBulkGetResult: …
values: Optional[Dict[str, Union[str, float, bool, Dict[str, object]]]]

Requested keys are paired with their values in an object.

One of the following:
str
float
bool
Dict[str, object]
class WorkersKVBulkGetResultWithMetadata: …
values: Optional[Dict[str, Optional[WorkersKVBulkGetResultWithMetadataValues]]]

Requested keys are paired with their values and metadata in an object.

metadata: object

The metadata associated with the key.

value: object

The value associated with the key.

expiration: Optional[float]

Expires the key at a certain time, measured in number of seconds since the UNIX epoch.

Get multiple key-value pairs

import os
from cloudflare import Cloudflare

client = Cloudflare(
    api_token=os.environ.get("CLOUDFLARE_API_TOKEN"),  # This is the default and can be omitted
)
response = client.kv.namespaces.bulk_get(
    namespace_id="0f2ac74b498b48028cb68387c421e279",
    account_id="023e105f4ecef8ad9ca31a8372d0c353",
    keys=["My-Key"],
)
print(response)
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "values": {
      "key1": "value1",
      "key2": "value2"
    }
  }
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "values": {
      "key1": "value1",
      "key2": "value2"
    }
  }
}